$.fn.tree=function (param) {var caller=this;if(typeof param === 'object' || !param){var options=param;var t=new Tree(caller,options);t.createTree();
t.initTree();caller.data('tree', t);}else{var t=caller.data('tree');if(!t) return;return t[param].apply(this, Array.prototype.slice.call(arguments,1));}
return caller;};
function Tree(caller,options){var tree=this;var caller = $(caller);var rootUlElement = '<ul class="dl-tree dl-tree-content ui-widget-content ui-corner-all ui-helper-clearfix"></ul>';var breadcrumbUIElement = '<ul class="dl-tree-breadcrumb ui-widget-content ui-corner-all ui-helper-clearfix"><li></li></ul>';var container = $('<div class="dl-tree-container ui-widget ui-widget-content ui-corner-all">'+rootUlElement+'</div>');var options=jQuery.extend({url: null,
breadcrumb: false,
linkHover: 'ui-state-hover',
nextMenuLink: 'ui-icon-triangle-1-e',
backLabel: 'Back',
breadcrumbRootLabel: 'Root',
maxHeight: 24 * 10,
width: 250,
onLoadError: null,
onAnyItemClick: null,
onClickLeaf: null,
onBeforeBack: null,
onLoaded: null,
onElementHover: null}, options);var backList = [];var currentBranch=null;var pathList = [];var scrollPosition=0;var linkList=[options.breadcrumbRootLabel];this.createTree=function(){container
.css({width: options.width})
.appendTo(caller);if(options.breadcrumb){tree.makeBreadcrumb();}else{tree.makeBackButton();}
checkMenuHeight(container.find('.dl-tree'));}
this.initTree=function(){if(!options.url){return false;}
tree.loadTree();}
this.back=function(){if(options.onBeforeBack){options.onBeforeBack.call($(this));}
linkList=linkList.slice(0, -1);tree.loadTree(backList[backList.length-1], true);};
this.loadTree=function (id,isBack,isReload) {var url=options.url;var data = {};if(id){var currentPathList=pathList.slice(0);if(!isBack){currentPathList.push(id);}else{currentPathList.pop();}
data.path=currentPathList.join(':');}
scrollPosition=0;if(isReload){var currentPathList=pathList.slice(0);data.path=currentPathList.join(':');scrollPosition=container.find('.dl-tree').scrollTop();}
container.addClass('dl-began-loading');$('.dl-tree-footer a', container).addClass('dl-disable-back');$('.dl-tree', container).addClass('ui-widget-overlay');$.ajax({url: url,
type: 'POST',
dataType: 'json',
data: data,
success: function (o) {if(isBack){pathList.pop();currentBranch=backList.pop();}if(id && !isBack){pathList.push(id);if(currentBranch) {backList.push(currentBranch);}
currentBranch=id;}if(!o){container.html('not found');return false;}
container
.html(rootUlElement);if(!o.length){caller.data('extra', o.extra);o=o.data;}
$.each(o,function (i) {var attr = '';$.each(o[i], function (field) {if(field == 'caption' ||
field == 'id') return;attr+=' '+field+'="'+o[i][field]+'"'});container.find('ul')
.append('<li><a id="'+o[i].id+'" '+attr+' href="#">'+o[i].caption+'</a></li>');});
tree.refresh();if(container.hasClass('dl-tree-empty')){container.removeClass('dl-tree-empty');}},
error: function (xhr,status) {$('.dl-tree', container).removeClass('ui-widget-overlay');$('.ui-state-loading', container).removeClass('ui-state-loading');if(options.onLoadError){options.onLoadError(xhr,status);}},
complete: function(){container.removeClass('dl-began-loading');if(currentBranch){$('.dl-tree-footer a', container)
.removeClass('dl-disable-back');}
$('.dl-tree-breadcrumb', container)
.removeClass('dl-disable-back');}});};
this.refresh=function(){container.find('ul, li a').addClass('ui-corner-all');container.find('a').attr('tabindex', '-1');if(options.linkHover){var allLinks=container.find('.dl-tree li a');allLinks
.hover(function(){if(container.hasClass('dl-began-loading')) return;var menuitem = $(this);$('.' + options.linkHover, container)
.removeClass(options.linkHover)
.blur();$(this)
.addClass(options.linkHover);if(options.onElementHover){options.onElementHover.call($(this),true);}},
function(){if(container.hasClass('dl-began-loading')) return;$(this)
.removeClass(options.linkHover)
.blur();if(options.onElementHover){options.onElementHover.call($(this),false);}}
);}if(options.breadcrumb){tree.makeBreadcrumb();}else{tree.makeBackButton();}
var topList=container.find('.dl-tree');checkMenuHeight(topList);
topList.find('a').each(function(){if($(this).attr('hc')){$(this)
.addClass('dl-tree-indicator')
.each(function(){$(this).html('<span>'+$(this).text()+'</span><span class="ui-icon dl-icon '+options.nextMenuLink+'"></span>');})
.click(function(){if(options.onAnyItemClick){options.onAnyItemClick($(this));}if(container.hasClass('dl-began-loading')) return;$(this).addClass('ui-state-loading');
$('.dl-tree-breadcrumb', container)
.addClass('dl-disable-back');linkList.push($('span:first', this).text());tree.loadTree($(this).attr('id'));});}else{$(this)
.addClass('dl-tree-leaf')
.click(function(){if(options.onAnyItemClick) {options.onAnyItemClick($(this));}if(options.onClickLeaf){return options.onClickLeaf($(this));}
return false;});}});topList.scrollTop(scrollPosition);if(options.onLoaded){options.onLoaded.call(container);checkMenuHeight(topList);}}
this.makeBackButton=function(){var backButton = $('<ul class="ui-widget-header ui-corner-all ui-helper-clearfix"></ul>');backButton.addClass('dl-tree-footer')
.appendTo(container);$('<a class="dl-back" href="#"><span class="ui-icon ui-icon-triangle-1-w"></span> <span>'+options.backLabel+'</span></a>')
.appendTo(backButton)
.addClass('dl-disable-back')
.click(function(){if(!$(this).hasClass('dl-disable-back')){tree.back();}
$(this).addClass('dl-disable-back');});}
this.makeBreadcrumb=function(){var breadcrumb = $('<ul class="ui-widget-header ui-corner-all ui-helper-clearfix"></ul>');for(var i=0, l=linkList.length;i<l-1; ++i){breadcrumb.append('<a href="#" pos="'+i+'">'+linkList[i]+'</a> / ');}
breadcrumb
.append('<span class="dl-breadcrumb-current">'+linkList[linkList.length-1]+'</span>')
.addClass('dl-disable-back');breadcrumb.find('a').click(function(){if(breadcrumb.hasClass('dl-disable-back')){return false;}
$('.dl-tree-breadcrumb', container)
.addClass('dl-disable-back');var pos = +($(this).attr('pos'));pathList=pathList.slice(0,pos);linkList=linkList.slice(0,pos+1);tree.reload();});breadcrumb.addClass('dl-tree-breadcrumb')
.prependTo(container);}
this.getCurrentPath=function(){return pathList.slice(0);}
this.reload=function(){tree.loadTree(null,false,true);}
this.getBreadcrumbLinks=function(){return linkList;}
var checkMenuHeight=function(el){var additionElement=options.breadcrumb ? $('.dl-tree-breadcrumb', container) : $('.dl-back', container);var additionHeight=additionElement.height();if(el.height() > options.maxHeight  - additionHeight){el.addClass('dl-tree-scroll')};el.css({height: options.maxHeight - additionHeight});};};